/*
 * Copyright (c) 1998, 2000, 2001 University of Utah and the Flux Group.
 * All rights reserved.
 * 
 * This file is part of Clack.
 * 
 * Clack is free software, also known as "open source."  You can redistribute
 * it and/or modify it under the terms of the GNU General Public License
 * (GPL), version 2, as published by the Free Software Foundation (FSF).
 * 
 * Clack is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GPL for more details.  You should have
 * received a copy of the GPL along with Clack; see the file COPYING.  If
 * not, write to the FSF, 59 Temple Place #330, Boston, MA 02111-1307, USA.
 * 
 * Clack is modelled on and includes some code fragments from MIT's Click
 * system (http://www.pdos.lcs.mit.edu/click/) which is copyright (c)
 * 1999-2000 Massachusetts Institute of Technology and also GPL'ed.
 * 
 * Users are requested, but not required, to send to csl-dist@cs.utah.edu any
 * improvements that they make and grant Univ. of Utah redistribution rights.
 */
/*
 * This file is derived from the OSKit's `oskit/fudp.h' file.
 */

#ifndef _OSKIT_FUDP_H_
#define _OSKIT_FUDP_H_

#include <clack/c/clack_types.h>
#include <netinet/in.h>
#include <clack/c/ethernet.h>
#include <clack/c/if_arp.h>

/*
 * What fake UDP implementation would be complete without a
 * corresponding fake ARP implementation?
 */
clack_error_t farp_lookup(const struct in_addr *ipaddr,
			 unsigned char out_ethaddr[ETHER_ADDR_SIZE]);
clack_error_t farp_add(const struct in_addr *ipaddr,
		      const unsigned char ethaddr[ETHER_ADDR_SIZE]);
void farp_remove(const struct in_addr *ipaddr);

#endif /* _OSKIT_FUDP_H_ */
