/*
 * Copyright (c) 2000, 2001 University of Utah and the Flux Group.
 * All rights reserved.
 * 
 * This file is part of Clack.
 * 
 * Clack is free software, also known as "open source."  You can redistribute
 * it and/or modify it under the terms of the GNU General Public License
 * (GPL), version 2, as published by the Free Software Foundation (FSF).
 * 
 * Clack is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GPL for more details.  You should have
 * received a copy of the GPL along with Clack; see the file COPYING.  If
 * not, write to the FSF, 59 Temple Place #330, Boston, MA 02111-1307, USA.
 * 
 * Clack is modelled on and includes some code fragments from MIT's Click
 * system (http://www.pdos.lcs.mit.edu/click/) which is copyright (c)
 * 1999-2000 Massachusetts Institute of Technology and also GPL'ed.
 * 
 * Users are requested, but not required, to send to csl-dist@cs.utah.edu any
 * improvements that they make and grant Univ. of Utah redistribution rights.
 */

#include <clack/c/packet.h>
#include <clack/c/packet_eth.h>
#include <clack/c/packet_ip.h>
#include <clack/c/fake_arp.h>
#include <arpa/inet.h>
#include <netinet/in.h>		/* in_addr */

#include <stdio.h>

extern unsigned char src[ETHER_ADDR_SIZE];

extern clack_error_t push_in1(clack_packet_t *p);
extern clack_error_t push_in2(clack_packet_t *p);

clack_error_t push(clack_packet_t *p)
{
//        struct ip *ip = (struct ip *) clack_packet_data(p);
        unsigned char ethaddr[ETHER_ADDR_SIZE];
        struct in_addr addr;

//        memcpy(&addr.s_addr,&ip->ip_dst,4);
        memcpy(&addr.s_addr,&p->anno.next_hop,4);
        if (farp_lookup(&addr, ethaddr) == 0) {
                add_eth_hdr(p, ethaddr, src, ETHERTYPE_IP);
                push_in1(p);
        } else {
                push_in2(p);
        }
        return 0;
}
