/*
 * Copyright (c) 2000, 2001 University of Utah and the Flux Group.
 * All rights reserved.
 * 
 * This file is part of Clack.
 * 
 * Clack is free software, also known as "open source."  You can redistribute
 * it and/or modify it under the terms of the GNU General Public License
 * (GPL), version 2, as published by the Free Software Foundation (FSF).
 * 
 * Clack is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GPL for more details.  You should have
 * received a copy of the GPL along with Clack; see the file COPYING.  If
 * not, write to the FSF, 59 Temple Place #330, Boston, MA 02111-1307, USA.
 * 
 * Clack is modelled on and includes some code fragments from MIT's Click
 * system (http://www.pdos.lcs.mit.edu/click/) which is copyright (c)
 * 1999-2000 Massachusetts Institute of Technology and also GPL'ed.
 * 
 * Users are requested, but not required, to send to csl-dist@cs.utah.edu any
 * improvements that they make and grant Univ. of Utah redistribution rights.
 */

#include <clack/c/packet.h>
#include <clack/c/packet_eth.h>
#include <arpa/inet.h>

void add_eth_hdr(clack_packet_t *p, 
                 unsigned char dst[ETHER_ADDR_SIZE], 
                 unsigned char src[ETHER_ADDR_SIZE], 
                 unsigned short type)
{
        struct ether_header *eth_hdr = clack_packet_UNSHIFT(p, struct ether_header);

	memcpy(eth_hdr->ether_dhost, dst, ETHER_ADDR_SIZE);
	memcpy(eth_hdr->ether_shost, src, ETHER_ADDR_SIZE);
	eth_hdr->ether_type = htons(type);
}

