/*
 * Copyright (c) 2000, 2001 University of Utah and the Flux Group.
 * All rights reserved.
 * 
 * This file is part of Clack.
 * 
 * Clack is free software, also known as "open source."  You can redistribute
 * it and/or modify it under the terms of the GNU General Public License
 * (GPL), version 2, as published by the Free Software Foundation (FSF).
 * 
 * Clack is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GPL for more details.  You should have
 * received a copy of the GPL along with Clack; see the file COPYING.  If
 * not, write to the FSF, 59 Temple Place #330, Boston, MA 02111-1307, USA.
 * 
 * Clack is modelled on and includes some code fragments from MIT's Click
 * system (http://www.pdos.lcs.mit.edu/click/) which is copyright (c)
 * 1999-2000 Massachusetts Institute of Technology and also GPL'ed.
 * 
 * Users are requested, but not required, to send to csl-dist@cs.utah.edu any
 * improvements that they make and grant Univ. of Utah redistribution rights.
 */

#ifndef _CLACK_PRINT_PACKET_H
#define	_CLACK_PRINT_PACKET_H

#include <clack/c/packet.h>
#include <clack/c/packet_eth.h>
#include <clack/c/packet_ip.h>
#include <clack/c/packet_icmp.h>
#include <clack/c/if_arp.h>

void print_ether(unsigned char ethaddr[ETHER_ADDR_SIZE]);
void print_IP(unsigned char ipaddr[4]);
void print_IP2(struct in_addr *a);
void print_ether_header(struct ether_header *e);
void print_ARP_header(struct arp_header *a);
void print_ether_ARP(struct ether_arp *ea);
void print_IP_header(struct ip *ip);
void print_ICMP_echo(struct icmphdr* i);

#endif /* _CLACK_PRINT_PACKET_H */
