/*
 * Copyright (c) 2000, 2001 University of Utah and the Flux Group.
 * All rights reserved.
 * 
 * This file is part of Clack.
 * 
 * Clack is free software, also known as "open source."  You can redistribute
 * it and/or modify it under the terms of the GNU General Public License
 * (GPL), version 2, as published by the Free Software Foundation (FSF).
 * 
 * Clack is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GPL for more details.  You should have
 * received a copy of the GPL along with Clack; see the file COPYING.  If
 * not, write to the FSF, 59 Temple Place #330, Boston, MA 02111-1307, USA.
 * 
 * Clack is modelled on and includes some code fragments from MIT's Click
 * system (http://www.pdos.lcs.mit.edu/click/) which is copyright (c)
 * 1999-2000 Massachusetts Institute of Technology and also GPL'ed.
 * 
 * Users are requested, but not required, to send to csl-dist@cs.utah.edu any
 * improvements that they make and grant Univ. of Utah redistribution rights.
 */

/*
 * Define osenv_mem in terms of malloc. Another way to do this would be
 * to indirect through a clack_memory allocator. Not sure it really
 * matters though.
 */

#include <stdio.h>
#include <malloc.h>
#include <stdlib.h>
#include <assert.h>

void *
osenv_mem_alloc(int size, int flags, unsigned align)
{
        void *block;

	assert(align == 0);

	block = malloc(size);
//	printf("osenv_mem_alloc: %p %d\n", block, size);
        return block;
}

void
osenv_mem_free(void *block, int flags, int size)
{
//	printf("osenv_mem_free:  %p %d\n", block, size);
	
        free(block);
}
